Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp	(revision 1024)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp	(revision 2090)
@@ -6,27 +6,49 @@
 #include "../include/change.h"
 
-#define MAX_NUM_TRI 250
-
 using namespace VMI;
-
-std::vector<VMI::vmiStep> VMI::mVMISteps;
-
-Change *VMI::createChange (Mesh *mesh, int e) {
-    Change *c;
-    
-    c = (Change*) malloc (sizeof(Change));
-    if (NULL == c) {
-        fprintf (stderr, "no more memory for mesh changes");
-        exit(1);
-    }
-    c->e = e;
-    c->u = mesh->edges[e].u;
-    c->v = mesh->edges[e].v;
-    c->modified = NULL;
-    c->deleted = NULL;
-    c->numDel = 0;
-    c->numMod = 0;
-    
-    return c;
+using namespace std;
+
+Geometry::MeshSimplificationSequence *VMI::mSequence	=	NULL;
+
+Change *VMI::createChange(Mesh *mesh, int e) {
+	Change *c;
+
+	c = (Change*) malloc (sizeof(Change));
+	if (NULL == c) {
+		fprintf (stderr, "no more memory for a mesh change\n");
+		exit(1);
+	}
+	c->e = e;
+	c->u = mesh->edges[e].u;
+	c->v = mesh->edges[e].v;
+	c->modified = NULL;
+	c->deleted = NULL;
+	c->numDel = 0;
+	c->numMod = 0;
+
+	computeChange(mesh, c);
+
+	return c;
+}
+
+Change *VMI::newChange(Mesh *mesh, int u, int v) {
+	Change *c;
+
+	c = (Change*) malloc (sizeof(Change));
+	if (NULL == c) {
+		fprintf (stderr, "no more memory for a mesh change\n");
+		exit(1);
+	}
+	c->e = -1; // Default edge, not used
+	c->u = u;
+	c->v = v;
+	c->modified = NULL;
+	c->deleted = NULL;
+	c->numDel = 0;
+	c->numMod = 0;
+
+	computeChange(mesh, c);
+
+	return c;
 }
 
@@ -91,5 +113,4 @@
 void VMI::modifyTriangle(Triangle *t, int c, int p)
 {
-
 	if ((int)t->indices[0] == c)
 		t->indices[0]= p;
@@ -100,5 +121,5 @@
 }
 
-int VMI::isATriangleToModify(Triangle *t, int c, int p)
+int VMI::isATriangleToModify(Triangle *t, int c)
 {
 	int u = t->indices[0],
@@ -109,86 +130,4 @@
 
 	return FALSE;
-}
-
-void VMI::modifyTriangles(Mesh *mesh, Change *c)
-{
-	int i, t;
-
-	for (i=0; i<c->numMod; i++)
-	{
-		t = c->modified[i].id;
-		modifyTriangle(&mesh->triangles[t], c->u, c->v);
-
-		//printf("New area of triangle %d:\n", t);
-		mesh->triangles[t].area = computeTriangleArea(mesh->vertices, &mesh->triangles[t]);
-
-		computeTriangleNormal(mesh->vertices, &mesh->triangles[t]);
-	}
-}
-
-void VMI::unmodifyTriangles(Mesh *mesh, Change *c)
-{
-	int i, t;
-
-	for (i=0; i<c->numMod; i++) {
-		t = c->modified[i].id;
-
-		memcpy(&mesh->triangles[t], &c->modified[i], sizeof(Triangle));
-		/*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
-			mesh->triangles[t].indices[1],
-			mesh->triangles[t].indices[2]);*/
-	}
-}
-
-void VMI::deleteTriangles(Mesh *mesh, Change *c)
-{
-	int i, t;
-
-	for (i=0; i<c->numDel; i++)
-	{
-		t = c->deleted[i].id;
-
-		//printf("Deleting triangle %d\n",t);
-		mesh->triangles[t].enable = FALSE;
-		mesh->currentNumTriangles--;
-	}
-}
-
-void VMI::undeleteTriangles(Mesh *mesh, Change *c)
-{
-	int i, t;
-
-	for (i=0; i<c->numDel; i++)
-	{
-		t = c->deleted[i].id;
-
-		memcpy(&mesh->triangles[t], &c->deleted[i], sizeof(Triangle));
-		/*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
-			mesh->triangles[t].indices[1], 
-			mesh->triangles[t].indices[2]);*/
-
-		mesh->triangles[t].enable = TRUE;
-		mesh->currentNumTriangles++;
-	}
-}
-
-int VMI::getTrianglesToModify(Mesh *mesh, int c, int p, Triangle *modified)
-{
-	GLuint i, num = 0;
-
-	for (i=0; i<mesh->numTriangles; i++)
-	{
-		if ((mesh->triangles[i].enable == TRUE) && 
-				isATriangleToModify(&mesh->triangles[i], c, p))
-		{
-
-			//printf("Triangle to modify %d\n", i);
-			// Save the original values of the triangle
-			memcpy(&modified[num], &mesh->triangles[i], sizeof(Triangle));
-			num++;
-		}
-	}
-
-	return num;
 }
 
@@ -211,48 +150,298 @@
 }
 
-int VMI::getTrianglesToDelete(Mesh *mesh, int numMod, Triangle *modified, Triangle *deleted, int c, int p)
-{
-	int i, num = 0;
-	GLuint t;
-
-	for (i=0; i<numMod; i++)
-	{
-		t = modified[i].id;
-
-		if (isATriangleToDelete(&mesh->triangles[t], c, p))
-		{                                             
-			//printf("Triangle to delete %d\n",t);                    
-			memcpy(&deleted[num], &modified[i], sizeof(Triangle));
-			num++;
-		}
-	}
-	return num;
-}
-
-void VMI::printList(Triangle *list, int n)
-{
-	int i;
-
-	for (i=0; i<n; i++)
-		printf("%d ",list[i].id);
-
-	printf("\n");
-}
-
-void VMI::deleteItem(Triangle *list, int *n, int item)
-{
-	int i, j;
-
-	for (i=0; i<*n; i++)
-	{
-		if (list[i].id == (GLuint)item)
-		{
-			// delete it
-			for (j =i + 1 ; j<*n; j++)
-				list[j - 1] = list[j];
-			(*n)--;
-			i--; // Delete all ocurrencies of an item
-		}
-	}
+void VMI::modifyTriangles(Mesh *mesh, Change *c)
+{
+	int i, t;
+
+	// Reallocate memory for new adjacent triangles from vertex v
+  if (c->numMod > 0) {
+      mesh->vertices[c->v].triangles = 
+          (GLuint *)realloc(mesh->vertices[c->v].triangles, 
+          (mesh->vertices[c->v].numTriangles + mesh->vertices[c->u].numTriangles) * sizeof(GLuint));
+  }
+
+	for (i=0; i<c->numMod; i++) {
+		t = c->modified[i].id;
+		modifyTriangle(&mesh->triangles[t], c->u, c->v);
+
+		//printf("New area of triangle %d:\n", t);
+		mesh->triangles[t].area = computeTriangleArea(mesh->vertices, &mesh->triangles[t]);
+
+		computeTriangleNormal(mesh->vertices, &mesh->triangles[t]);
+
+		// Update vertex adjacency c->v
+		addItem((int *)mesh->vertices[c->v].triangles, (int *)&mesh->vertices[c->v].numTriangles, t);
+	}
+}
+
+void VMI::unmodifyTriangles(Mesh *mesh, Change *c)
+{
+	int i, t;
+
+	for (i=0; i<c->numMod; i++) {
+		t = c->modified[i].id;
+
+		memcpy(&mesh->triangles[t], &c->modified[i], sizeof(Triangle));
+		/*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
+			mesh->triangles[t].indices[1],
+			mesh->triangles[t].indices[2]);*/
+
+		// Update vertex adjacency c->v
+		delItem((int *)mesh->vertices[c->v].triangles, (int *)&mesh->vertices[c->v].numTriangles, t);
+	}
+
+}
+
+int VMI::hasEdge(Triangle *t, int e) {
+    int e0 = t->edges[0],
+        e1 = t->edges[1],
+        e2 = t->edges[2];
+    
+    if ((e == e0) || (e == e1) || (e == e2)) return TRUE;
+
+    return FALSE;
+}
+
+void VMI::getEdges(Triangle *t, Change *c, int *l, int *r) {
+
+    // Default edges
+    *l = -1;
+    *r = -1;
+
+    // Set edge l and r
+    if ((int)t->edges[0] == c->e) {
+        *l = t->edges[1];
+        *r = t->edges[2];
+        if ((int)mesh->edges[*l].u == c->v || (int)mesh->edges[*l].v == c->v)
+            swap(l, r);
+    } else if ((int)t->edges[1] == c->e) {
+        *l = t->edges[0];
+        *r = t->edges[2];
+        if ((int)mesh->edges[*l].u == c->v || (int)mesh->edges[*l].v == c->v)
+            swap(l, r);
+    } else if ((int)t->edges[2] == c->e) {
+        *l = t->edges[0];
+        *r = t->edges[1];
+        if ((int)mesh->edges[*l].u == c->v || (int)mesh->edges[*l].v == c->v)
+            swap(l, r);
+    }
+}
+
+void VMI::swap(int *i, int *j) {
+    int t;
+
+    t = *i;
+    *i = *j;
+    *j = t;
+}
+
+void VMI::deleteTriangles(Mesh *mesh, Change *c)
+{
+	    int i, j, t, v;
+#ifdef USE_EDGE_ADJACENCY
+    int t1, l, r;
+#endif
+    
+    for (i=0; i<c->numDel; i++) {
+        t = c->deleted[i].id;
+
+        //printf("%d(%d,%d) Deleting triangle %d\n",c->e, c->u, c->v, t);
+
+        // Update vertex adjacency
+        for (j=0; j<3; j++) {
+            v = c->deleted[i].indices[j];
+            
+            delItem((int *)mesh->vertices[v].triangles,(int *)&mesh->vertices[v].numTriangles,t);
+        }
+
+#ifdef USE_EDGE_ADJACENCY
+        // Update triangle edge adjancency
+        // The modified triangles have to be calculated before
+        // Set edge l and r
+        getEdges(&c->deleted[i], c, &l, &r);
+        //printf("e%d(%d,%d): l:%d r:%d\n", c->e, c->u, c->v, l, r);
+        // Find triangle that contains edge l
+        for (j=0; j<c->numMod; j++)
+            if (hasEdge(&c->modified[j], l)) {
+                // Change edge l by r in the Mesh
+                t1 = c->modified[j].id;
+                //printf("t:%d %d %d %d\n", t1, mesh->triangles[t1].edges[0], mesh->triangles[t1].edges[1] ,mesh->triangles[t1].edges[2]);
+                if (mesh->triangles[t1].edges[0] == (GLuint)l) mesh->triangles[t1].edges[0] = r;
+                if (mesh->triangles[t1].edges[1] == (GLuint)l) mesh->triangles[t1].edges[1] = r;
+                if (mesh->triangles[t1].edges[2] == (GLuint)l) mesh->triangles[t1].edges[2] = r;
+                //printf("t:%d %d %d %d\n", t1, mesh->triangles[t1].edges[0], mesh->triangles[t1].edges[1] ,mesh->triangles[t1].edges[2]);
+                break;
+            }
+
+        // Delete edge l
+        if (l != -1) mesh->edges[l].enable = FALSE;
+#endif
+        mesh->triangles[t].enable = FALSE;
+        mesh->currentNumTriangles--;
+    }
+}
+
+void VMI::undeleteTriangles(Mesh *mesh, Change *c) {
+    int i, j, t, v;
+    
+    for (i=0; i<c->numDel; i++) {
+        t = c->deleted[i].id;
+        
+        //printf("Undeleting triangle %d\n",t);
+
+        memcpy(&mesh->triangles[t], &c->deleted[i], sizeof(Triangle));
+        /*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
+                                  mesh->triangles[t].indices[1], 
+                                  mesh->triangles[t].indices[2]);*/
+
+        // Update vertex adjacency
+        for (j=0; j<3; j++) {
+            v = c->deleted[i].indices[j];
+            
+            addItem((int *)mesh->vertices[v].triangles,(int *)&mesh->vertices[v].numTriangles,t);
+        }
+#ifdef USE_EDGE_ADJACENCY
+        // Enable adjacent edges
+        for (j=0; j<3; j++) {
+            mesh->edges[mesh->triangles[t].edges[j]].enable = TRUE;
+        }
+#endif
+        mesh->triangles[t].enable = TRUE;
+        mesh->currentNumTriangles++;
+    }
+}
+
+Triangle *VMI::getTrianglesToModify(Mesh *mesh, Change *c, GLuint *numMod) {
+  int i, t;
+  Triangle *modified = NULL;
+
+  // Allocating memory
+  modified = (Triangle *)malloc(mesh->vertices[c->u].numTriangles * sizeof(Triangle));
+  *numMod = 0;
+  
+  for (i=0; i<(int)mesh->vertices[c->u].numTriangles; i++) {
+      
+      t = mesh->vertices[c->u].triangles[i];
+      
+      if ((mesh->triangles[t].enable == TRUE) && 
+          !isATriangleToDelete(&mesh->triangles[t], c->u, c->v)) {
+          
+          //printf("Triangle to modify %d\n", t);
+          // Save the original values of the triangle
+          memcpy(&modified[*numMod], &mesh->triangles[t], sizeof(Triangle));
+          (*numMod)++;
+      }
+  }
+  return modified;
+}
+
+Triangle *VMI::getTrianglesToDelete(Mesh *mesh, Change *c, GLuint *numDel) {
+  int i, t;
+  Triangle *deleted = NULL;
+  
+  // Allocating memory
+  deleted = (Triangle *)malloc(mesh->vertices[c->u].numTriangles * sizeof(Triangle));
+  *numDel = 0;
+
+  for (i=0; i<(int)mesh->vertices[c->u].numTriangles; i++) {
+      
+      t = mesh->vertices[c->u].triangles[i];
+
+      if ((mesh->triangles[t].enable == TRUE) &&
+          isATriangleToDelete(&mesh->triangles[t], c->u, c->v)) {
+                                                    
+          //printf("Triangle to delete %d\n",t);                    
+          memcpy(&deleted[*numDel], &mesh->triangles[t], sizeof(Triangle));
+          (*numDel)++;
+      }
+  }
+  return deleted;
+}
+
+void VMI::deleteEdges(Mesh *mesh, Change *c) {
+    int i, e;
+#ifndef USE_EDGE_ADJACENCY
+    int n0, n1, n2;
+#else
+    int j, u, v;
+#endif
+
+#ifdef USE_EDGE_ADJACENCY
+    for (i=0; i<c->numDel; i++) {
+        
+        for (j=0; j<3; j++) {
+            e = c->deleted[i].edges[j];
+            if (e != c->e) {
+                u = mesh->edges[e].u;
+                v = mesh->edges[e].v;
+                if (u == c->u || v == c->u) {
+                    //printf("%d\n",j);
+                    mesh->edges[e].enable = FALSE;
+                }
+            }
+        }
+        //getchar();
+    }
+#else
+    for (i=0; i<c->numDel; i++) {
+
+        n0 = c->deleted[i].indices[0];
+        n1 = c->deleted[i].indices[1];
+        n2 = c->deleted[i].indices[2];
+
+        if ((n0 == c->u && n1 != c->v) || (n1 == c->u && n0 != c->v)) {
+            e = findEdge(mesh->edges, mesh->numEdges, n0, n1);
+
+            //printf("a\n");
+            if (e != -1)
+                mesh->edges[e].enable = FALSE;
+        }
+
+        if ((n1 == c->u && n2 != c->v) || (n2 == c->u && n1 != c->v)) {
+            e = findEdge(mesh->edges, mesh->numEdges, n1, n2);
+            
+            //printf("b\n");
+            if (e != -1)
+                mesh->edges[e].enable = FALSE;
+        }
+
+        if ((n0 == c->u && n2 != c->v) || (n2 == c->u && n0 != c->v)) {
+            e = findEdge(mesh->edges, mesh->numEdges, n0, n2);
+            
+            //printf("c\n");
+            if (e != -1)
+                mesh->edges[e].enable = FALSE;
+        }
+        //getchar();
+    }
+#endif
+}
+
+void VMI::modifyEdges(Mesh *mesh, Change *c) {
+    int e, u, v;
+    
+    // Update mesh and heap
+    for(e = 0; e < (int)mesh->numEdges; e++) {
+        
+        if (mesh->edges[e].enable == TRUE) {
+            
+            // Modify edge
+            if ((int)mesh->edges[e].u == c->u)
+                mesh->edges[e].u = c->v;
+            
+            if ((int)mesh->edges[e].v == c->u)
+                mesh->edges[e].v = c->v;
+            
+            // Check edge
+            u = mesh->edges[e].u;
+            v = mesh->edges[e].v;
+            
+            // if the edge is not valid, we simply delete it
+            if ((u == v) || 
+                (u == c->u) || (v == c->u)) 
+                
+                mesh->edges[e].enable = FALSE;
+        }
+    }
 }
 
@@ -260,53 +449,17 @@
 
 // Compute the triangle mesh changes due to a heap node simplification
-void VMI::computeChanges(Mesh *mesh, Change *c)
-{
-	Triangle m[MAX_NUM_TRI], d[MAX_NUM_TRI/2];
-	int numMod = getTrianglesToModify(mesh, c->u, c->v, m);
-	int numDel = getTrianglesToDelete(mesh, numMod, m, d, c->u, c->v);
-	int i;
-
-	//printf("d %d\n",numDel);
-	//printList(d, numDel);
-
-	for (i=0; i<numDel; i++)
-		deleteItem(m, &numMod, d[i].id);
-
-	//printf("m %d\n",numMod);
-	//printList(m, numMod);
-	//getchar();
-
-	c->numDel = numDel;
-	// Free memory
-	if (c->deleted != NULL) free(c->deleted);
-	// Allocate memory
-	c->deleted = (Triangle *)malloc(sizeof(Triangle) * numDel);
-	
-	if (c->deleted == NULL)
-	{
-		fprintf(stderr, "Error allocating memory\n");
-		exit(1);
-	}
-	
-	memcpy(c->deleted, d, sizeof(Triangle) * numDel);
-
-	c->numMod = numMod;
-	
-	// Free memory
-	if (c->modified != NULL) free(c->modified);
-	
-	// Allocate memory
-	c->modified = (Triangle *)malloc(sizeof(Triangle) * numMod);
-	
-	if (c->modified == NULL)
-	{
-		fprintf(stderr, "Error allocating memory\n");
-		exit(1);
-	}
-	
-	memcpy(c->modified, m, sizeof(Triangle) * numMod);
-
-	//printChange(c);
-	//getchar();
+void VMI::computeChange(Mesh *mesh, Change *c) {
+  GLuint numMod, numDel;
+  Triangle *m = getTrianglesToModify(mesh, c, &numMod),
+            *d = getTrianglesToDelete(mesh, c, &numDel);
+  
+  c->numDel   = numDel;
+  c->deleted  = d;
+  
+  c->numMod   = numMod;
+  c->modified = m;
+
+  //printChange(c);
+  //getchar();
 }
 
@@ -316,12 +469,17 @@
 	modifyTriangles(mesh, c);
 
+	// This function must be called after modifyTriangles()
 	deleteTriangles(mesh, c);
 
+	// Delete vertex u
 	mesh->vertices[c->u].enable = FALSE;
 	mesh->currentNumVertices--;
+
+	//printMesh(mesh);
+	//getchar();
 }
 
 void VMI::undoChange(Mesh *mesh, Change *c)
-{    
+{
 	unmodifyTriangles(mesh, c);
 
@@ -330,54 +488,64 @@
 	mesh->vertices[c->u].enable = TRUE;
 	mesh->currentNumVertices++;
-}
-
+
+	//printMesh(mesh);
+	//getchar();
+}
+
+/*
 namespace VMI{
 std::map<int, INTVECTOR> inversemap;
 }
+*/
 
 //	Save simplification sequence in Geometry Game Tools format.
-extern void	VMI::saveSimplificationSequence(Change	*c)
-{
-
-	int stepnum= 1;
-	for(INTVECTOR::iterator it= inversemap[c->u].begin(); it!=inversemap[c->u].end(); it++)
+extern void	VMI::saveSimplificationSequence(Change	*c,int obligatory)
+{
+	Geometry::MeshSimplificationSequence::Step	step;
+
+	if (mSequence == NULL)
 	{
-		vmiStep	step;
-		step.mV0	=	*it;
-		step.mV1	=	c->v;
-
-		//	If only one triangle has been deleted.
-		if (c->numDel == 1)
-		{
-			step.mT0	=	c->deleted[0].id;
-			step.mT1	=	c->deleted[0].id;
-		}
-		//	If two triangles have been deleted.
-		else
-		{
-			step.mT0	=	c->deleted[0].id;
-			step.mT1	=	c->deleted[1].id;
-		}
-
-		step.x	=	0.0;
-		step.y	=	0.0;
-		step.z	=	0.0;
-
-		//	Write obligatory field.
-		if (stepnum==inversemap[c->u].size())
-			step.obligatory	=	0;
-		else
-			step.obligatory	=	1;
-		stepnum++;
-
-		//	List of new triangles.
-		//	For each modified triangle.
-		for (int	i = 0;	i < c->numMod;	i++)
-		{
-			step.mModfaces.push_back(c->modified[i].id);
-		}
-
-		//	Add step to list of changes.
-		mVMISteps.push_back(step);
-	}
-}
+		mSequence	=	new Geometry::MeshSimplificationSequence();
+	}
+
+	step.mV0	=	c->v;
+	step.mV1	=	c->u;
+
+	//	Debug.
+	cout	<<	"----> V0: "
+				<<	step.mV0
+				<<	" V1: "
+				<<	step.mV1
+				<<	endl;
+
+	//	If only one triangle has been deleted.
+	if (c->numDel == 1)
+	{
+		step.mT0	=	c->deleted[0].id;
+		step.mT1	=	c->deleted[0].id;
+	}
+	//	If two triangles have been deleted.
+	else
+	{
+		step.mT0	=	c->deleted[0].id;
+		step.mT1	=	c->deleted[1].id;
+	}
+
+	step.x	=	0.0;
+	step.y	=	0.0;
+	step.z	=	0.0;
+
+	//	Write obligatory field.
+	step.obligatory	=	obligatory;
+
+	//	List of new triangles.
+	//	For each modified triangle.
+	for (int	i = 0;	i < c->numMod;	i++)
+	{
+		step.mModfaces.push_back(c->modified[i].id);
+	}
+
+	//	Add step to list of changes.
+	mSequence->mSteps.push_back(step);
+}
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/camera.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/camera.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/camera.cpp	(revision 2090)
@@ -174,36 +174,47 @@
 
     switch (type) {
-    case OCTAHEDRON:
-        cameras = (Camera *)malloc(sizeof(Camera) * type);
+    case 0:
+        cameras = (Camera *)malloc(sizeof(Camera) * OCTAHEDRON);
         if (cameras == NULL) {
             fprintf(stderr, "Error allocating memory\n");
             exit(1);
         }
-        *numCameras = type;
+        *numCameras = OCTAHEDRON;
         drawOctahedron(cameras, radius);
         break;
-    case ICOSAHEDRON:
-        cameras = (Camera *)malloc(sizeof(Camera) * type);
+    case 1:
+        cameras = (Camera *)malloc(sizeof(Camera) * CUBE);
         if (cameras == NULL) {
             fprintf(stderr, "Error allocating memory\n");
             exit(1);
         }
-        *numCameras = type;
-        drawIcosahedron(cameras, radius);
+        *numCameras = CUBE;
+        drawCube(cameras, radius);
         break;
-    case DODECAHEDRON:
-        cameras = (Camera *)malloc(sizeof(Camera) * type);
+    case 2:
+        cameras = (Camera *)malloc(sizeof(Camera) * ICOSAHEDRON);
         if (cameras == NULL) {
             fprintf(stderr, "Error allocating memory\n");
             exit(1);
         }
-        *numCameras = type;
+        *numCameras = ICOSAHEDRON;
+        drawIcosahedron(cameras, radius);
+        break;
+    case 3:
+        cameras = (Camera *)malloc(sizeof(Camera) * DODECAHEDRON);
+        if (cameras == NULL) {
+            fprintf(stderr, "Error allocating memory\n");
+            exit(1);
+        }
+        *numCameras = DODECAHEDRON;
         drawDodecahedron(cameras, radius);
         break;
     default:
-        printf("Error cameras not defined\n");
+        printf("Error, cameras not defined\n");
         exit(1);
         break;
     }
+
+    printf("Number of cameras: %d\n", *numCameras);
 
     return cameras;
@@ -506,2 +517,58 @@
     copyToCameras(cameras, 12, vertices);
 }
+
+void VMI::drawCube(Camera *cameras, GLdouble r) // any radius in which the polyhedron is inscribed
+{
+    GLdouble vertices[8][3] = {
+        {-1, -1, 1},   // vertex v0
+        {1,  -1, 1},   // vertex v1
+        {1,  -1, -1},  // vertex v2
+        {-1, -1, -1},  // vertex v3
+        {-1, 1,  1},   // vertex v4
+        {1,  1,  1},   // vertex v5
+        {1,  1,  -1},  // vertex v6 
+        {-1, 1,  -1},  // vertex v7
+    }; // 8 vertices with x, y, z coordinates
+    int i;
+#ifdef DRAW_DEBUG
+    int tindex[12][3] = {
+        
+        {0, 1, 4}, //polygon v0,v1,v4
+        {1, 5, 4}, //polygon v1,v5,v4
+        {1, 2, 5}, //polygon v1,v2,v5
+        {2, 6, 5}, //polygon v2,v6,v5
+        {2, 3, 6}, //polygon v2,v3,v6
+        {3, 7, 6}, //polygon v3,v7,v6
+        {3, 0, 7}, //polygon v3,v0,v7
+        {0, 4, 7}, //polygon v0,v4,v7
+        {4, 5, 7}, //polygon v4,v5,v7
+        {5, 6, 7}, //polygon v5,v6,v7
+        {3, 2, 0}, //polygon v3,v2,v0
+        {2, 1, 0}, //polygon v2,v1,v0
+    };
+#endif
+    
+    for(i=0; i<8; i++)
+    {
+        vertices[i][0]*=r;
+        vertices[i][1]*=r;
+        vertices[i][2]*=r;
+    }
+
+    // map vertices to 12 faces 
+#ifdef DRAW_DEBUG
+    
+    for (i=0; i<12; i++) { 
+        
+        glBegin(GL_POINTS );
+        glVertex3fv(&vertices[tindex[i][0]][0]); 
+        glVertex3fv(&vertices[tindex[i][1]][0]); 
+        glVertex3fv(&vertices[tindex[i][2]][0]);    
+        glEnd(); 
+    }
+
+#endif
+    
+    copyToCameras(cameras, 8, vertices);
+}
+
